PPATH  Prime Path
The ministers of the cabinet were quite upset by the
message from the Chief of Security stating that they
would all have to change the fourdigit room numbers
on their offices.
— It is a matter of security to change such things
every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good
reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also
a prime. You will just have to paste four new
digits over the four old ones on your office door.
— No, it's not that simple. Suppose that I change the
first digit to an 8, then the number will read 8033
which is not a prime!
— I see, being the prime minister you cannot stand
having a nonprime number on your door even for a
few seconds.
— Correct! So I must invent a scheme for going from
1033 to 8179 by a path of prime numbers where
only one digit is changed from one prime to the
next prime.
Now, the minister of finance, who had been eavesdropping,
intervened.
— No unnecessary expenditure, please! I happen to
know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to
minimize the cost. You don't know some very cheap
software gurus, do you?
— In fact, I do. You see, there is this programming
contest going on...
Help the prime minister to find the cheapest prime path between any two given fourdigit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033 1733 3733 3739 3779 8779 8179The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are fourdigit primes (without leading zeros).
Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Example
Input: 3 1033 8179 1373 8017 1033 1033 Output: 6 7 0
hide comments
holmesherlock:
20170328 15:34:10
good question ,,beginners must give it a try 

sultania23:
20170327 15:09:14
nice problem ....test cases are weak... 

ashu121:
20170324 13:26:29
very good application of BFS :) 

sucide:
20170323 07:50:21
Ac in one go!


lord_poseidon:
20170318 15:49:33
Accepted in one go, use bfs and sieve :) 

akt_1998:
20170304 20:23:37
Pretty sweet ;)


sarthakshah30:
20170304 15:19:07
NICE BFS + BIT TRICKS + Sieve of eratosthenes :) Last edit: 20170304 15:20:10 

vineetpratik:
20170304 15:07:00
nice one , Hint: Convert to graph 

vladimira:
20170302 07:07:27
30 minutes. AC in one go! 

abhishekrahul:
20170119 13:52:25
enjoyed solving the problem ,very good question ,, it took some time ,, my 100th on spoj ............. 
Added by:  overwise 
Date:  20071002 
Time limit:  2s 
Source limit:  50000B 
Memory limit:  1536MB 
Cluster:  Cube (Intel G860) 
Languages:  All except: ERL JSRHINO NODEJS PERL6 VB.NET 
Resource:  ACM ICPC NWERC 2006 